Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1875)
@@ -102,4 +102,11 @@
    }
    CATCH
+   
+   /*!
+    * Get the local data grid size, ie the size of the compressed grid (inside the workflow)
+    * \return The size od the compressed grid
+    */
+    StdSize  CGrid::getLocalDataSize(void) { return getClientDistribution()->getLocalDataSize();}
+
 
    /*!
@@ -326,4 +333,5 @@
    CATCH_DUMP_ATTR
 
+   //ym obsolete -> to be removed later
    void CGrid::checkMaskIndex(bool doSendingIndex)
    TRY
@@ -334,6 +342,6 @@
        if (this->isChecked && doSendingIndex && !isIndexSent) 
        { 
-         if (isScalarGrid())  sendIndexScalarGrid();
-         else  sendIndex();
+         if (isScalarGrid())  /*sendIndexScalarGrid()*/;
+         else  /*sendIndex()*/;
          this->isIndexSent = true; 
        }
@@ -1453,46 +1461,117 @@
   CATCH_DUMP_ATTR
 
-  void CGrid::sendIndexScalarGrid()
-  TRY
-  {
+  void CGrid::sendIndexScalarGrid(CContextClient* client, const string& gridId)
+  TRY
+  {
+    if (sendIndexScalarGrid_done_.count(client)!=0) return ;
+    else sendIndexScalarGrid_done_.insert(client) ;
+
     CContext* context = CContext::getCurrent();
-    storeIndex_toSrv_.clear();
-    std::list<CContextClient*>::iterator it;
-
-    for (it=clients.begin(); it!=clients.end(); ++it)
-    {
-      CContextClient* client = *it;
-      int receiverSize = client->serverSize;
-
-      CEventClient event(getType(), EVENT_ID_INDEX);
-      list<CMessage> listMsg;
-      list<CArray<size_t,1> > listOutIndex;
-
+    
+    string serverGridId = gridId.empty() ? serverGridId=this->getId() : serverGridId=gridId ;
+
+    int receiverSize = client->serverSize;
+
+    CEventClient event(getType(), EVENT_ID_INDEX);
+    list<CMessage> listMsg;
+    list<CArray<size_t,1> > listOutIndex;
+
+    if (client->isServerLeader())
+    {
+      const std::list<int>& ranks = client->getRanksServerLeader();
+      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+      {
+        int rank = *itRank;
+        int nb = 1;
+        storeIndex_toSrv_[client].insert(std::make_pair(rank, CArray<int,1>(nb)));
+        listOutIndex.push_back(CArray<size_t,1>(nb));
+
+        CArray<int, 1>& outLocalIndexToServer = storeIndex_toSrv_[client][rank];
+        CArray<size_t, 1>& outGlobalIndexOnServer = listOutIndex.back();
+
+        for (int k = 0; k < nb; ++k)
+        {
+          outGlobalIndexOnServer(k) = 0;
+          outLocalIndexToServer(k)  = 0;
+        }
+
+        if (context->getServiceType()==CServicesManager::CLIENT)  // -> what about for coupling probably unusefull to be check
+          storeIndex_fromSrv_.insert(std::make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
+
+        listMsg.push_back(CMessage());
+        listMsg.back() << serverGridId << isCompressible_ << listOutIndex.back();
+
+        event.push(rank, 1, listMsg.back());
+      }
+      client->sendEvent(event);
+    }
+    else
+    {
+      const std::list<int>& ranks = client->getRanksServerNotLeader();
+      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+      {
+        int rank = *itRank;
+        int nb = 1;          
+        CArray<int, 1> outLocalIndexToServer(nb);
+        for (int k = 0; k < nb; ++k)
+        {
+          outLocalIndexToServer(k)  = 0;
+        }
+
+        if (context->getServiceType()==CServicesManager::CLIENT)
+          storeIndex_fromSrv_.insert(std::make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
+      }
+      client->sendEvent(event);
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CGrid::sendIndex(CContextClient* client, const string& gridId)
+  TRY
+  {
+    if (sendIndex_done_.count(client)!=0) return ;
+    else sendIndex_done_.insert(client) ;
+    CContext* context = CContext::getCurrent();
+    string serverGridId = gridId.empty() ? this->getId() : gridId ;
+
+
+
+    int receiverSize = client->serverSize;
+
+    CEventClient event(getType(), EVENT_ID_INDEX);
+    int rank;
+    list<CMessage> listMsg;
+    list<CArray<size_t,1> > listOutIndex;
+    const CDistributionClient::GlobalLocalDataMap& globalLocalIndexSendToServer = getClientDistribution()->getGlobalLocalDataSendToServer();
+    CDistributionClient::GlobalLocalDataMap::const_iterator itbIndex = globalLocalIndexSendToServer.begin(), itIndex,
+                                                            iteIndex = globalLocalIndexSendToServer.end();
+    itIndex = itbIndex;                                                              
+
+    if (!doGridHaveDataDistributed(client))
+    {
       if (client->isServerLeader())
       {
+        int indexSize = globalLocalIndexSendToServer.size();
+        CArray<size_t,1> outGlobalIndexOnServer(indexSize);
+        CArray<int,1> outLocalIndexToServer(indexSize);
+        for (int idx = 0; itIndex != iteIndex; ++itIndex, ++idx)
+        {
+          outGlobalIndexOnServer(idx) = itIndex->first;
+          outLocalIndexToServer(idx) = itIndex->second;
+        }
+
         const std::list<int>& ranks = client->getRanksServerLeader();
         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
         {
-          int rank = *itRank;
-          int nb = 1;
-          storeIndex_toSrv_[client].insert(std::make_pair(rank, CArray<int,1>(nb)));
-          listOutIndex.push_back(CArray<size_t,1>(nb));
-
-          CArray<int, 1>& outLocalIndexToServer = storeIndex_toSrv_[client][rank];
-          CArray<size_t, 1>& outGlobalIndexOnServer = listOutIndex.back();
-
-          for (int k = 0; k < nb; ++k)
-          {
-            outGlobalIndexOnServer(k) = 0;
-            outLocalIndexToServer(k)  = 0;
-          }
-
-          if (context->getServiceType()==CServicesManager::CLIENT)  
-            storeIndex_fromSrv_.insert(std::make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
+          storeIndex_toSrv_[client].insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
+          if (context->getServiceType()==CServicesManager::CLIENT)  // -> what about for coupling probably unusefull to be check
+            storeIndex_fromSrv_.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
+          
+          listOutIndex.push_back(CArray<size_t,1>(outGlobalIndexOnServer));
 
           listMsg.push_back(CMessage());
-          listMsg.back() << getId( )<< isCompressible_ << listOutIndex.back();
-
-          event.push(rank, 1, listMsg.back());
+          listMsg.back() << serverGridId << isCompressible_ << listOutIndex.back();
+
+          event.push(*itRank, 1, listMsg.back());
         }
         client->sendEvent(event);
@@ -1500,143 +1579,69 @@
       else
       {
-        const std::list<int>& ranks = client->getRanksServerNotLeader();
-        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+         int indexSize = globalLocalIndexSendToServer.size();
+         CArray<int,1> outLocalIndexToServer(indexSize);
+         for (int idx = 0; itIndex != iteIndex; ++itIndex, ++idx)
+         {
+           outLocalIndexToServer(idx) = itIndex->second;
+         }
+
+         const std::list<int>& ranks = client->getRanksServerNotLeader();
+         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+         {
+           storeIndex_fromSrv_.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
+         }
+         client->sendEvent(event);
+       }
+    }
+    else
+    {
+      CClientServerMapping::GlobalIndexMap::const_iterator iteGlobalMap, itGlobalMap;
+      itGlobalMap = globalIndexOnServer_[receiverSize].begin();
+      iteGlobalMap = globalIndexOnServer_[receiverSize].end();
+
+      std::map<int,std::vector<int> >localIndexTmp;
+      std::map<int,std::vector<size_t> > globalIndexTmp;
+      for (; itGlobalMap != iteGlobalMap; ++itGlobalMap)
+      {
+        int serverRank = itGlobalMap->first;
+        int indexSize = itGlobalMap->second.size();
+        const std::vector<size_t>& indexVec = itGlobalMap->second;
+        for (int idx = 0; idx < indexSize; ++idx)
         {
-          int rank = *itRank;
-          int nb = 1;          
-          CArray<int, 1> outLocalIndexToServer(nb);
-          for (int k = 0; k < nb; ++k)
+          itIndex = globalLocalIndexSendToServer.find(indexVec[idx]);
+          if (iteIndex != itIndex)
           {
-            outLocalIndexToServer(k)  = 0;
-          }
-
-          if (context->getServiceType()==CServicesManager::CLIENT)
-            storeIndex_fromSrv_.insert(std::make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
-        }
-        client->sendEvent(event);
-      }
-    }
-  }
-  CATCH_DUMP_ATTR
-
-  void CGrid::sendIndex(void)
-  TRY
-  {
-    CContext* context = CContext::getCurrent();
-    storeIndex_toSrv_.clear();
-    std::list<CContextClient*>::iterator it;
-
-    for (it=clients.begin(); it!=clients.end(); ++it)
-    {
-      CContextClient* client = *it;
-      int receiverSize = client->serverSize;
-
-      CEventClient event(getType(), EVENT_ID_INDEX);
-      int rank;
-      list<CMessage> listMsg;
-      list<CArray<size_t,1> > listOutIndex;
-      const CDistributionClient::GlobalLocalDataMap& globalLocalIndexSendToServer = getClientDistribution()->getGlobalLocalDataSendToServer();
-      CDistributionClient::GlobalLocalDataMap::const_iterator itbIndex = globalLocalIndexSendToServer.begin(), itIndex,
-                                                              iteIndex = globalLocalIndexSendToServer.end();
-      itIndex = itbIndex;                                                              
-
-      if (!doGridHaveDataDistributed(client))
-      {
-        if (client->isServerLeader())
-        {
-          int indexSize = globalLocalIndexSendToServer.size();
-          CArray<size_t,1> outGlobalIndexOnServer(indexSize);
-          CArray<int,1> outLocalIndexToServer(indexSize);
-          for (int idx = 0; itIndex != iteIndex; ++itIndex, ++idx)
-          {
-            outGlobalIndexOnServer(idx) = itIndex->first;
-            outLocalIndexToServer(idx) = itIndex->second;
-          }
-
-          const std::list<int>& ranks = client->getRanksServerLeader();
-          for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-          {
-            storeIndex_toSrv_[client].insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
-            if (context->getServiceType()==CServicesManager::CLIENT)
-              storeIndex_fromSrv_.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
-            
-            listOutIndex.push_back(CArray<size_t,1>(outGlobalIndexOnServer));
-
-            listMsg.push_back(CMessage());
-            listMsg.back() << getId() << isCompressible_ << listOutIndex.back();
-
-            event.push(*itRank, 1, listMsg.back());
-          }
-          client->sendEvent(event);
-        }
-        else
-        {
-           int indexSize = globalLocalIndexSendToServer.size();
-           CArray<int,1> outLocalIndexToServer(indexSize);
-           for (int idx = 0; itIndex != iteIndex; ++itIndex, ++idx)
-           {
-             outLocalIndexToServer(idx) = itIndex->second;
-           }
-
-           const std::list<int>& ranks = client->getRanksServerNotLeader();
-           for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-           {
-             storeIndex_fromSrv_.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
-           }
-           client->sendEvent(event);
-         }
-      }
-      else
-      {
-        CClientServerMapping::GlobalIndexMap::const_iterator iteGlobalMap, itGlobalMap;
-        itGlobalMap = globalIndexOnServer_[receiverSize].begin();
-        iteGlobalMap = globalIndexOnServer_[receiverSize].end();
-
-        std::map<int,std::vector<int> >localIndexTmp;
-        std::map<int,std::vector<size_t> > globalIndexTmp;
-        for (; itGlobalMap != iteGlobalMap; ++itGlobalMap)
-        {
-          int serverRank = itGlobalMap->first;
-          int indexSize = itGlobalMap->second.size();
-          const std::vector<size_t>& indexVec = itGlobalMap->second;
-          for (int idx = 0; idx < indexSize; ++idx)
-          {
-            itIndex = globalLocalIndexSendToServer.find(indexVec[idx]);
-            if (iteIndex != itIndex)
-            {
-              globalIndexTmp[serverRank].push_back(itIndex->first);
-              localIndexTmp[serverRank].push_back(itIndex->second);
-            }
+            globalIndexTmp[serverRank].push_back(itIndex->first);
+            localIndexTmp[serverRank].push_back(itIndex->second);
           }
         }
-
-        for (int ns = 0; ns < connectedServerRank_[receiverSize].size(); ++ns)
+      }
+
+      for (int ns = 0; ns < connectedServerRank_[receiverSize].size(); ++ns)
+      {
+        rank = connectedServerRank_[receiverSize][ns];
+        int nb = 0;
+        if (globalIndexTmp.end() != globalIndexTmp.find(rank))
+          nb = globalIndexTmp[rank].size();
+
+        storeIndex_toSrv_[client].insert(make_pair(rank, CArray<int,1>(nb)));
+        listOutIndex.push_back(CArray<size_t,1>(nb));
+
+        CArray<int, 1>& outLocalIndexToServer = storeIndex_toSrv_[client][rank];
+        CArray<size_t, 1>& outGlobalIndexOnServer = listOutIndex.back();
+
+        for (int k = 0; k < nb; ++k)
         {
-          rank = connectedServerRank_[receiverSize][ns];
-          int nb = 0;
-          if (globalIndexTmp.end() != globalIndexTmp.find(rank))
-            nb = globalIndexTmp[rank].size();
-
-          storeIndex_toSrv_[client].insert(make_pair(rank, CArray<int,1>(nb)));
-          listOutIndex.push_back(CArray<size_t,1>(nb));
-
-          CArray<int, 1>& outLocalIndexToServer = storeIndex_toSrv_[client][rank];
-          CArray<size_t, 1>& outGlobalIndexOnServer = listOutIndex.back();
-
-          for (int k = 0; k < nb; ++k)
-          {
-            outGlobalIndexOnServer(k) = globalIndexTmp[rank].at(k);
-            outLocalIndexToServer(k)  = localIndexTmp[rank].at(k);
-          }
-
-          storeIndex_fromSrv_.insert(make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
-          listMsg.push_back(CMessage());
-          listMsg.back() << getId()  << isCompressible_ << listOutIndex.back();
-
-          event.push(rank, nbSenders_[receiverSize][rank], listMsg.back());
+          outGlobalIndexOnServer(k) = globalIndexTmp[rank].at(k);
+          outLocalIndexToServer(k)  = localIndexTmp[rank].at(k);
         }
 
-        client->sendEvent(event);
-      }
+        storeIndex_fromSrv_.insert(make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
+        listMsg.push_back(CMessage());
+        listMsg.back() << serverGridId  << isCompressible_ << listOutIndex.back();
+
+        event.push(rank, nbSenders_[receiverSize][rank], listMsg.back());
+      }
+      client->sendEvent(event);
     }
   }
@@ -2235,9 +2240,44 @@
     gridPtr->sendCreateChild(this->getId(),client);
     this->sendAllAttributesToServer(client);
-    if (isScalarGrid())  sendIndexScalarGrid();
-    else  sendIndex();
+    if (isScalarGrid())  sendIndexScalarGrid(client);
+    else  sendIndex(client);
     this->sendAllDomains(client);
     this->sendAllAxis(client);
     this->sendAllScalars(client);
+  }
+
+  void CGrid::sendGridToCouplerOut(CContextClient* client, const string& fieldId)
+  {
+    if (sendGridToCouplerOut_done_.count(client)!=0) return ;
+    else sendGridToCouplerOut_done_.insert(client) ;
+    string gridId="_grid_of_"+fieldId ;
+    this->sendAllAttributesToServer(client, gridId);
+    
+    if (isScalarGrid())  sendIndexScalarGrid(client, gridId);
+    else sendIndex(client, gridId);
+
+    const auto& domVect = getDomains() ;
+    for (int pos=0; pos<domVect.size();pos++) domVect[pos]->sendDomainToCouplerOut(client, fieldId, pos);
+
+    const auto& axisVect=getAxis() ;
+    for (int pos=0; pos<axisVect.size();pos++) axisVect[pos]->sendAxisToCouplerOut(client, getGlobalDimension(), getAxisPositionInGrid()[pos], fieldId, pos);
+
+    const auto& scalVect=getScalars() ;
+    for (int pos=0; pos<scalVect.size();pos++) scalVect[pos]->sendScalarToCouplerOut(client, fieldId, pos);
+  }
+
+  void CGrid::makeAliasForCoupling(const string& fieldId)
+  {
+    string gridId="_grid_of_"+fieldId ;
+    createAlias(gridId) ;
+    
+    const auto& domVect = getDomains() ;
+    for (int pos=0; pos<domVect.size();pos++) domVect[pos]->makeAliasForCoupling(fieldId, pos);
+
+    const auto& axisVect=getAxis() ;
+    for (int pos=0; pos<axisVect.size();pos++) axisVect[pos]->makeAliasForCoupling(fieldId, pos);
+
+    const auto& scalVect=getScalars() ;
+    for (int pos=0; pos<scalVect.size();pos++) scalVect[pos]->makeAliasForCoupling(fieldId, pos);
   }
 
@@ -2365,13 +2405,45 @@
   other context (coupling)
   */
-  bool CGrid::checkIfCompleted(void)
+  bool CGrid::isCompleted(void)
   {
     setDomainList();
-    for (auto domainId : domList_) if (!CDomain::get(domainId)->checkIfCompleted()) return false ;
+    for (auto domainId : domList_) if (!CDomain::get(domainId)->isCompleted()) return false ;
     setAxisList() ;
-    for (auto axisId : axisList_) if (!CAxis::get(axisId)->checkIfCompleted()) return false ;
+    for (auto axisId : axisList_) if (!CAxis::get(axisId)->isCompleted()) return false ;
     setScalarList() ;
-    for (auto scalarId : scalarList_) if (!CScalar::get(scalarId)->checkIfCompleted()) return false ;
+    for (auto scalarId : scalarList_) if (!CScalar::get(scalarId)->isCompleted()) return false ;
     return true ;
+  }
+
+  /*!
+  \brief impose that all elements of the grid are complete
+  Before make any grid processing, we must be sure that all grid information elements have
+  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+  other context (coupling)
+  */
+  void CGrid::setCompleted(void)
+  {
+    setDomainList();
+    for (auto domainId : domList_) CDomain::get(domainId)->setCompleted() ;
+    setAxisList() ;
+    for (auto axisId : axisList_) CAxis::get(axisId)->setCompleted() ;
+    setScalarList() ;
+    for (auto scalarId : scalarList_) CScalar::get(scalarId)->setCompleted() ;
+  }
+
+/*!
+  \brief impose that all elements of the grid are incomplete
+  Before make any grid processing, we must be sure that all grid information elements have
+  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+  other context (coupling)
+  */
+  void CGrid::unsetCompleted(void)
+  {
+    setDomainList();
+    for (auto domainId : domList_) CDomain::get(domainId)->unsetCompleted() ;
+    setAxisList() ;
+    for (auto axisId : axisList_) CAxis::get(axisId)->unsetCompleted() ;
+    setScalarList() ;
+    for (auto scalarId : scalarList_) CScalar::get(scalarId)->unsetCompleted() ;
   }
 
@@ -2904,8 +2976,8 @@
       clientsSet.insert(contextClient);
     }
-    for (int i=0; i<this->getDomains().size(); i++)
-    	this->getDomains()[i]->setContextClient(contextClient);
-    for (int i=0; i<this->getAxis().size(); i++)
-    	this->getAxis()[i]->setContextClient(contextClient);
+    for (auto domain : getDomains()) domain->setContextClient(contextClient);
+    for (auto axis : getAxis()) axis->setContextClient(contextClient);
+    for (auto scalar : getScalars()) scalar->setContextClient(contextClient);
+   
   }
   CATCH_DUMP_ATTR
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1875)
@@ -90,4 +90,10 @@
 
          StdSize  getDataSize(void) ;
+
+         /**
+          * Get the local data grid size, ie the size of the compressed grid (inside the workflow)
+          * \return The size od the compressed grid
+          */
+         StdSize  getLocalDataSize(void) ;
 
          /// Entrees-sorties de champs
@@ -151,5 +157,13 @@
       private:
          std::set<CContextClient*> sendGridToFileServer_done_ ;
-      
+     
+      public:
+         void sendGridToCouplerOut(CContextClient* client, const string& fieldId) ;
+      private:
+         std::set<CContextClient*> sendGridToCouplerOut_done_ ;
+
+      public:
+         void makeAliasForCoupling(const string& fieldId) ;
+
       public:
          void sendAddDomain(const std::string& id,CContextClient* contextClient);
@@ -170,7 +184,16 @@
          static void recvIndex(CEventServer& event);
          void recvIndex(vector<int> ranks, vector<CBufferIn*> buffers, CContextServer* server);
-         void sendIndex(void);
-         void sendIndexScalarGrid();
-
+       
+       public:  
+         void sendIndex(CContextClient* client, const string& gridId="");
+       private:
+          set<CContextClient*> sendIndex_done_ ;
+       
+       public:
+         void sendIndexScalarGrid(CContextClient* client, const string& gridId="");
+       private:
+          set<CContextClient*> sendIndexScalarGrid_done_ ;
+      
+       public:
          void setContextClient(CContextClient* contextClient);
 
@@ -221,5 +244,8 @@
          bool hasTransform();
          size_t getGlobalWrittenSize(void) ;
-         bool checkIfCompleted(void) ;
+         
+         bool isCompleted(void) ;
+         void setCompleted(void) ;
+         void unsetCompleted(void) ;
 
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 1875)
@@ -68,42 +68,4 @@
 
   }
-
-  /*!
-  \brief Check if a scalar is completed
-  Before make any scalar processing, we must be sure that all scalar informations have
-  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
-  other context (coupling). So all direct reference of the scalar (scalar_ref) must be also completed
-  \return true if scalar and scalar reference are completed
-  */
-  bool CScalar::checkIfCompleted(void)
-  {
-    if (hasDirectScalarReference()) if (!getDirectScalarReference()->checkIfCompleted()) return false;
-    return isCompleted_ ;
-  }
-
-  /*!
-  \brief Set a scalar as completed
-   When all information about a scalar have been received, the scalar is tagged as completed and is
-   suitable for processing
-  */
-  void CScalar::setCompleted(void)
-  {
-    if (hasDirectScalarReference()) getDirectScalarReference()->setCompleted() ;
-    isCompleted_=true ;
-  }
-
-  /*!
-  \brief Set a scalar as uncompleted
-   When informations about a scalar are expected from a grid reading from file or coupling, the scalar is 
-   tagged as uncompleted and is not suitable for processing
-  */
-  void CScalar::setUncompleted(void)
-  {
-    if (hasDirectScalarReference()) getDirectScalarReference()->setUncompleted() ;
-    isCompleted_=false ;
-  }
-
-
-
 
   /*!
@@ -187,14 +149,50 @@
         refScalar[i]->setTransformations(scalar->getAllTransformations());
   }
-
+ 
   void CScalar::sendScalarToFileServer(CContextClient* client)
   {
     if (sendScalarToFileServer_done_.count(client)!=0) return ;
     else sendScalarToFileServer_done_.insert(client) ;
-
     StdString scalarDefRoot("scalar_definition");
     CScalarGroup* scalarPtr = CScalarGroup::get(scalarDefRoot);
     this->sendAllAttributesToServer(client);
   }
+
+  void CScalar::sendScalarToCouplerOut(CContextClient* client, const string& fieldId, int posInGrid)
+  {
+    if (sendScalarToCouplerOut_done_.count(client)!=0) return ;
+    else sendScalarToCouplerOut_done_.insert(client) ;
+
+    string scalarId="_scalar["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+   
+    if (!scalar_ref.isEmpty())
+    {
+      auto scalar_ref_tmp=scalar_ref.getValue() ;
+      scalar_ref.reset() ; // remove the reference, find an other way to do that more cleanly
+      this->sendAllAttributesToServer(client, scalarId)  ;
+      scalar_ref = scalar_ref_tmp ;
+    }
+    else this->sendAllAttributesToServer(client, scalarId)  ;
+
+
+    this->sendAllAttributesToServer(client, scalarId);
+  }  
+
+  void CScalar::makeAliasForCoupling(const string& fieldId, int posInGrid)
+  {
+    const string scalarId = "_scalar["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+    this->createAlias(scalarId) ;
+  }
+
+  void CScalar::setContextClient(CContextClient* contextClient)
+  TRY
+  {
+    if (clientsSet.find(contextClient)==clientsSet.end())
+    {
+      clients.push_back(contextClient) ;
+      clientsSet.insert(contextClient);
+    }
+  }
+  CATCH_DUMP_ATTR
   /*!
     Parse children nodes of a scalar in xml file.
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 1875)
@@ -72,13 +72,17 @@
             void checkAttributesOnClient();
             virtual void parse(xml::CXMLNode & node);
-
-            bool checkIfCompleted(void) ;
-            void setCompleted(void) ;
-            void setUncompleted(void) ;
-         
+        
          public:
             void sendScalarToFileServer(CContextClient* client) ;
          private:
             std::set<CContextClient*> sendScalarToFileServer_done_ ;
+
+         public:
+            void sendScalarToCouplerOut(CContextClient* client, const string& fieldId, int posInGrid) ;
+         private:
+            std::set<CContextClient*> sendScalarToCouplerOut_done_ ;
+         
+         public:
+            void makeAliasForCoupling(const string& fieldId, int posInGrid) ;
 
          public:
@@ -89,5 +93,11 @@
            CTransformation<CScalar>* addTransformation(ETranformationType transType, const StdString& id="");
            bool isEqual(CScalar* scalar);
-
+        private:  
+          /** Clients that have to send a scalar. There can be multiple clients in case of secondary server, otherwise only one client. */
+         std::list<CContextClient*> clients;
+         std::set<CContextClient*> clientsSet;
+        public:
+          void setContextClient(CContextClient* contextClient) ;
+        
          private:
            std::set<StdString> relFiles;
@@ -103,6 +113,25 @@
            /** define if the scalar is completed or not ie all attributes have been received before in case 
                of grid reading from file or coupling */ 
-           bool isCompleted_=true ;  
+      private:
+         /** define if the scalar is completed or not ie all attributes have been received before in case 
+             of grid reading from file or coupling */ 
+         bool isCompleted_=true ;  
+      public:     
+         /*!
+           \brief Check if a scalar is completed
+           Before make any scalar processing, we must be sure that all scalar informations have
+           been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+           other context (coupling). So all direct reference of the scalar (scalar_ref) must be also completed
+           \return true if scalar and scalar reference are completed
+          */
+         bool isCompleted(void)
+         {
+           if (hasDirectScalarReference()) if (!getDirectScalarReference()->isCompleted()) return false;
+           else return isCompleted_ ;
+         }
+         void setCompleted(void) { isCompleted_=true ; }
+         void unsetCompleted(void) { isCompleted_=false ; }
 
+      private:
             DECLARE_REF_FUNC(Scalar,scalar)
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template.hpp	(revision 1875)
@@ -56,8 +56,8 @@
          static void ClearAllAttributes(void);
          std::map<int, size_t> getMinimumBufferSizeForAttributes(CContextClient* client);
-         void sendAttributToServer(const string& id, CContextClient* client);
-         void sendAttributToServer(CAttribute& attr, CContextClient* client) ;
-         void sendAllAttributesToServer(CContextClient* client);
-         void sendAddItem(const string& id, int itemType, CContextClient* client);
+         void sendAttributToServer(const string& id, CContextClient* client, const string& objectId="");
+         void sendAttributToServer(CAttribute& attr, CContextClient* client, const string& objectId="") ;
+         void sendAllAttributesToServer(CContextClient* client, const string& objectId="");
+         void sendAddItem(const string& id, int itemType, CContextClient* client, const string& objectId="");
          static void recvAttributFromClient(CEventServer& event) ;
          static bool dispatchEvent(CEventServer& event) ;
